pangomm: Pango::TabArray Class Reference

pangomm 2.46.0

Public Member Functions | Static Public Member Functions | Protected Attributes | Related Functions | List of all members
Pango::TabArray Class Reference

A Pango::TabArray contains an array of tab stops. More...

`#include <pangomm/tabarray.h>`

## Public Member Functions
| TabArray ()
| TabArray (PangoTabArray* gobject, bool make_a_copy=true)
| TabArray (const TabArray& other)
TabArray& | operator= (const TabArray& other)
| TabArray (TabArray&& other) noexcept
TabArray& | operator= (TabArray&& other) noexcept
| ~TabArray () noexcept
void | swap (TabArray& other) noexcept
PangoTabArray* | gobj ()
| Provides access to the underlying C instance. More...
const PangoTabArray* | gobj () const
| Provides access to the underlying C instance. More...
PangoTabArray* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs. More...
| TabArray (int initial_size, bool positions_in_pixels=true)
int | get_size () const
| Gets the number of tab stops in tab_array. More...
void | resize (int new_size)
| Resizes a tab array. More...
void | set_tab (int tab_index, TabAlign alignment, int location)
| Sets the alignment and location of a tab stop. More...
std::pair< TabAlign, int > | get_tab (int tab_index) const
| Gets the alignment and position of a tab stop. More...
Glib::ArrayHandle< std::pair< TabAlign, int > > | get_tabs () const
| Gets an array of std::pairs containing the tab stop alignments and tab positions. More...
bool | get_positions_in_pixels () const
| Returns `true` if the tab positions are in pixels, `false` if they are in Pango units. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Attributes
PangoTabArray* | gobject_

## Related Functions
(Note that these are not member functions.)
void | swap (TabArray& lhs, TabArray& rhs) noexcept
Pango::TabArray | wrap (PangoTabArray* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A Pango::TabArray contains an array of tab stops.

Each tab stop has an alignment and a position.

## Constructor & Destructor Documentation

## ◆ TabArray() [1/5]

Pango::TabArray::TabArray | ( |  | ) |

## ◆ TabArray() [2/5]

Pango::TabArray::TabArray | ( | PangoTabArray * | gobject,
|  | bool | make_a_copy = `true`
| ) |  |
| explicit

## ◆ TabArray() [3/5]

Pango::TabArray::TabArray | ( | const TabArray& | other | ) |

## ◆ TabArray() [4/5]

Pango::TabArray::TabArray | ( | TabArray&& | other | ) |
| noexcept

## ◆ ~TabArray()

Pango::TabArray::~TabArray | ( |  | ) |
| noexcept

## ◆ TabArray() [5/5]

Pango::TabArray::TabArray | ( | int | initial_size,
|  | bool | positions_in_pixels = `true`
| ) |  |
| explicit

## Member Function Documentation

## ◆ get_positions_in_pixels()

bool Pango::TabArray::get_positions_in_pixels | ( |  | ) | const

Returns `true` if the tab positions are in pixels, `false` if they are in Pango units.

Returns
  Whether positions are in pixels.

## ◆ get_size()

int Pango::TabArray::get_size | ( |  | ) | const

Gets the number of tab stops in tab_array.

Returns
  The number of tab stops in the array.

## ◆ get_tab()

std::pair<TabAlign,int> Pango::TabArray::get_tab | ( | int | tab_index | ) | const

Gets the alignment and position of a tab stop.

Returns
  An std::pair<TabAlign, int>. The first element represents the tab stop alignment, the second one is the tab position.

## ◆ get_tabs()

Glib::ArrayHandle< std::pair<TabAlign,int> > Pango::TabArray::get_tabs | ( |  | ) | const

Gets an array of std::pairs containing the tab stop alignments and tab positions.

Returns
  An array of std::pair<TabAlign, int>. The first element in each pair represents the tab stop alignment, the second one is the tab position.

## ◆ get_type()

static GType Pango::TabArray::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

PangoTabArray* Pango::TabArray::gobj | ( |  | ) |
| inline

Provides access to the underlying C instance.

## ◆ gobj() [2/2]

const PangoTabArray* Pango::TabArray::gobj | ( |  | ) | const
| inline

Provides access to the underlying C instance.

## ◆ gobj_copy()

PangoTabArray* Pango::TabArray::gobj_copy | ( |  | ) | const

Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs.

## ◆ operator=() [1/2]

TabArray& Pango::TabArray::operator= | ( | const TabArray& | other | ) |

## ◆ operator=() [2/2]

TabArray& Pango::TabArray::operator= | ( | TabArray&& | other | ) |
| noexcept

## ◆ resize()

void Pango::TabArray::resize | ( | int | new_size | ) |

Resizes a tab array.

You must subsequently initialize any tabs that were added as a result of growing the array.

Parameters

  new_size | New size of the array.

## ◆ set_tab()

void Pango::TabArray::set_tab | ( | int | tab_index,
|  | TabAlign | alignment,
|  | int | location
| ) |  |

Sets the alignment and location of a tab stop.

alignment must always be Pango::TAB_LEFT in the current implementation.

Parameters

  tab_index | The index of a tab stop.
  alignment | Tab alignment.
  location | Tab location in Pango units.

## ◆ swap()

void Pango::TabArray::swap | ( | TabArray& | other | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ swap()

void swap | ( | TabArray& | lhs,
|  | TabArray& | rhs
| ) |  |
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

## ◆ wrap()

Pango::TabArray wrap | ( | PangoTabArray * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

## Member Data Documentation

## ◆ gobject_

PangoTabArray* Pango::TabArray::gobject_
| protected